/*  MegaPad
 *  Copyright (C) 2007 NHerv
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <string.h>
#include <math.h>
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <sdl/sdl.h>
#include <sdl/sdl_keyboard.h>
#include <sdl/sdl_keysym.h>
#include <sdl/sdl_joystick.h>
#include <sdl/sdl_version.h>

#include "PAD.h"

#pragma comment(lib, "sdl.lib")
#pragma comment(lib, "sdlmain.lib")

HWND GShwnd;
RECT WinSize, WinClipSize;
POINT CursorPos, CentPos;
int WinHeight=0, WinWidth=0;
HINSTANCE hInst=NULL;

WNDPROC GSwndProc;

Point WinCenter, WinCenterOnScr;
int Logging;
int axisSense;
int pressure[2];

u8 *Buffer;
u8 PadMode[2];
int DualShock2;
int sdlResult=1;
int Byte, Command, Length, Locked[2], ConfMode[2];
int VibS[2];
int VibB[2];
int VibF[2][2];
int uPad;

u16 ButtonStat[2];
u8 lX[2];
u8 lY[2];
u8 rX[2];
u8 rY[2];

u8 Cmd40[2][8]     ={{0xff, 0x5a, 0x00, 0x00, 0x02, 0x00, 0x00, 0x5a},
				 	 {0xff, 0x5a, 0x00, 0x00, 0x02, 0x00, 0x00, 0x5a}};
u8 Cmd41[2][8]     ={{0xff, 0x5a, 0xff, 0xff, 0x03, 0x00, 0x00, 0x5a},
					 {0xff, 0x5a, 0xff, 0xff, 0x03, 0x00, 0x00, 0x5a}};
u8 Cmd42[2][20]    ={{0xff, 0x5a, 0xff, 0xff, 0x80, 0x80, 0x80, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
					 {0xff, 0x5a, 0xff, 0xff, 0x80, 0x80, 0x80, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}};
u8 Cmd43[2][8]     ={{0xff, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
					 {0xff, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}};
u8 Cmd44[2][8]     ={{0xff, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
				 	 {0xff, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}};
u8 Cmd45[2][8]     ={{0xff, 0x5a, 0x03, 0x02, 0x01, 0x02, 0x01, 0x00},
					 {0xff, 0x5a, 0x03, 0x02, 0x01, 0x02, 0x01, 0x00}};
u8 Cmd46[2][8]     ={{0xff, 0x5a, 0x00, 0x00, 0x01, 0x02, 0x00, 0x0a},
					 {0xff, 0x5a, 0x00, 0x00, 0x01, 0x02, 0x00, 0x0a}};
u8 Cmd47[2][8]     ={{0xff, 0x5a, 0x00, 0x00, 0x02, 0x00, 0x01, 0x00},
					 {0xff, 0x5a, 0x00, 0x00, 0x02, 0x00, 0x01, 0x00}};
u8 Cmd4C[2][8]     ={{0xff, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
				 	 {0xff, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}};
u8 Cmd4D[2][8]     ={{0xff, 0x5a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
					 {0xff, 0x5a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
u8 Cmd4F[2][8]     ={{0xff, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5a},
				 	 {0xff, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5a}};
u8 ButtonMask[2][4]={{0xff, 0xff, 0x03, 0x00},
					 {0xff, 0xff, 0x03, 0x00}};

u8 PadID[2]={0x41, 0x41};

SDL_Joystick *joy[5][4];
PadConf Pad[2][1];
keyEvent KeyEvent;

void SetButtonState(int pad, int index, int pressed, int btnpress);
void SetButtonStateJA(int pad, int index, int axisval, int dir);
void PADsetMode(int pad, int mode);
void LOG(char *fmt, ...);
void LoadConfig(), SaveConfig();
LRESULT WINAPI PadWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

extern FILE *padLog;

int AlwaysSC, CrossCur;
extern int timer;
int padInit;

extern char *libraryName;

//Version is : revision.major.minor
const unsigned char version  = PS2E_PAD_VERSION;	//PS2E version to make sure the plugin shows up in the lists.
const unsigned char revision = 1;
const unsigned char major    = 3;
const unsigned char minor	 = 3;

void SysMessage(char *fmt, ...){
	va_list list;
	char tmp[512];
	va_start(list,fmt);
	vsprintf(tmp,fmt,list);
	va_end(list);
	MessageBox(0, tmp, "MegaPad Message", 0);
}

void SetEditText(HWND edit, char *fmt, ...){
	va_list list;
	char tmp[512];
	va_start(list,fmt);
	vsprintf(tmp,fmt,list);
	va_end(list);
	Edit_SetText(edit, tmp);
}

void InitPadConf(){
	int i, j;
	for(i=0; i<=1; i++){
		Pad[i][1].enabled=0;
		for(j=0; j<=24; j++){
			Pad[i][1].keys.type[j]=0;
			Pad[i][1].keys.num[j]=0;
			Pad[i][1].keys.index[j]=0;
			Pad[i][1].keys.dir[j]=0;
		}
	}
}

void SaveConfig(){
	FILE *conffile;
	int i, j;
	conffile=fopen("inis/MegaPad.ini", "w"); //Write
	if(conffile==NULL){
		SysMessage("Could not open config file, error %i", GetLastError());
		return;
	}
	fprintf(conffile, "[MegaPad %i.%i.%i config file]\n", revision, major, minor); //Header, to make sure this config file is the good version.
	for(i=0; i<=1; i++)
	{
		fprintf(conffile, "Joy%i_Enabled=%i\n", i+1, Pad[i][1].enabled);
		for(j=0; j<=24; j++)
		{
			fprintf(conffile, "Joy%i_Button%i_Type=%i\n", i+1, j, Pad[i][1].keys.type[j]);
			fprintf(conffile, "Joy%i_Button%i_Num=%i\n", i+1, j, Pad[i][1].keys.num[j]);
			fprintf(conffile, "Joy%i_Button%i_Index=%i\n", i+1, j, Pad[i][1].keys.index[j]);
			fprintf(conffile, "Joy%i_Button%i_Dir=%i\n", i+1, j, Pad[i][1].keys.dir[j]);
		}
	}
	fprintf(conffile, "Logging=%i\n", Logging);
	fprintf(conffile, "AxisSense=%i\n", axisSense);
	fprintf(conffile, "AlwaysShowCursor=%i\n", AlwaysSC);
	fprintf(conffile, "CrossCursor=%i\n", CrossCur);
	fclose(conffile);
}

void LoadConfig(){
	FILE *conffile;
	int i, j;
	int rev=0, mjr=0, mnr=0;
	int unused1=0, unused2=0;
	conffile=fopen("inis/MegaPad.ini", "r"); //Read
	if(conffile==NULL){ //No config file, or the file of an older version ? Let's create a new file.
creation:
		CreateFile("inis/MegaPad.ini", GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, 0, NULL);
		Pad[0][1].enabled=1;
		Pad[1][1].enabled=1;
		axisSense=1000;
		SaveConfig();
		return;
	}
	fscanf(conffile, "[MegaPad %i.%i.%i config file]\n", &rev, &mjr, &mnr);
	if(rev!=revision || mjr!=major)goto creation;
	for(i=0; i<=1; i++)
	{
		fscanf(conffile, "Joy%i_Enabled=%i\n", &unused1, &Pad[i][1].enabled);
		for(j=0; j<=24; j++)
		{
			fscanf(conffile, "Joy%i_Button%i_Type=%i\n", &unused1, &unused2, &Pad[i][1].keys.type[j]);
			fscanf(conffile, "Joy%i_Button%i_Num=%i\n", &unused1, &unused2, &Pad[i][1].keys.num[j]);
			fscanf(conffile, "Joy%i_Button%i_Index=%i\n", &unused1, &unused2, &Pad[i][1].keys.index[j]);
			fscanf(conffile, "Joy%i_Button%i_Dir=%i\n", &unused1, &unused2, &Pad[i][1].keys.dir[j]);
		}
	}
	fscanf(conffile, "Logging=%i\n", &Logging);
	fscanf(conffile, "AxisSense=%i\n", &axisSense);
	fscanf(conffile, "AlwaysShowCursor=%i\n", &AlwaysSC);
	fscanf(conffile, "CrossCursor=%i\n", &CrossCur);
#ifndef _DEBUG
	free(&unused1); free(&unused2);
#endif
	fclose(conffile);
}

int lbutton=0;
int rbutton=0;
int padopen=0;
static int disabled=0;

void FillGUI(HWND hW, int padn){
	int j, l, m;
	int key=0;
	char keyName[21];
	for(j=IDC_X; j<=IDC_AS; j++)
	{
		if(j<=IDC_DOWN){
			l=j+20;
			m=j-1076;
		}else if(j>=IDC_SELECT && j<=IDC_RDOWN){
			l=j+21;
			m=j-1076;
		}else if(j>=IDC_LUP && j<=IDC_LDOWN){
			l=j+4;
			m=j-1105;
		}else if(j==IDC_AS){
			l=j+1;
			m=24;
		}
		switch(Pad[padn][1].keys.type[m]){
		case 1: //Keyboard
			key=Pad[padn][1].keys.num[m];
			if(key>=0x30 && key<=0x39 || key>=0x25 && key<=0x28 || key>=0x21 && key<=0x24 || key>=0x29 && key<=0x2f)
			{
				GetKeyNameText(MapVirtualKey(key, 0)<<16|1<<24, keyName, sizeof(keyName));
			}else{
				GetKeyNameText(MapVirtualKey(key, 0)<<16, keyName, sizeof(keyName));
			}
			SetEditText(GetDlgItem(hW, l), "%s", keyName);
			break;
		case 2: //Joystick button
			SetEditText(GetDlgItem(hW, l), "Joy%i_Button%i", Pad[padn][1].keys.index[m]+1, Pad[padn][1].keys.num[m]+1);
			break;
		case 3: //Joystick POV
			switch(Pad[padn][1].keys.dir[m])
			{
			case 1: //Up
				SetEditText(GetDlgItem(hW, l), "Joy%i_Hat%i_Up", Pad[padn][1].keys.index[m]+1, Pad[padn][1].keys.num[m]+1);
				break;
			case 2: //Right
				SetEditText(GetDlgItem(hW, l), "Joy%i_Hat%i_Right", Pad[padn][1].keys.index[m]+1, Pad[padn][1].keys.num[m]+1);
				break;
			case 3: //Up-Right
				SetEditText(GetDlgItem(hW, l), "Joy%i_Hat%i_UpRight", Pad[padn][1].keys.index[m]+1, Pad[padn][1].keys.num[m]+1);
				break;
			case 4: //Down 
				SetEditText(GetDlgItem(hW, l), "Joy%i_Hat%i_Down", Pad[padn][1].keys.index[m]+1, Pad[padn][1].keys.num[m]+1);
				break;
			case 6: //Down-Right
				SetEditText(GetDlgItem(hW, l), "Joy%i_Hat%i_DownRight", Pad[padn][1].keys.index[m]+1, Pad[padn][1].keys.num[m]+1);
				break;
			case 8: //Left
				SetEditText(GetDlgItem(hW, l), "Joy%i_Hat%i_Left", Pad[padn][1].keys.index[m]+1, Pad[padn][1].keys.num[m]+1);	
				break;
			case 9: //Up-Left
				SetEditText(GetDlgItem(hW, l), "Joy%i_Hat%i_UpLeft", Pad[padn][1].keys.index[m]+1, Pad[padn][1].keys.num[m]+1);
				break;
			case 12: //Down-Left
				SetEditText(GetDlgItem(hW, l), "Joy%i_Hat%i_DownLeft", Pad[padn][1].keys.index[m]+1, Pad[padn][1].keys.num[m]+1);
				break;
			}
			break;
		case 4: //Joystick axis
			switch(Pad[padn][1].keys.dir[m])
			{
			case 1: //Min
				SetEditText(GetDlgItem(hW, l), "Joy%i_Axis%i_Min", Pad[padn][1].keys.index[m]+1, Pad[padn][1].keys.num[m]+1);
				break;
			case 2: //Max
				SetEditText(GetDlgItem(hW, l), "Joy%i_Axis%i_Max", Pad[padn][1].keys.index[m]+1, Pad[padn][1].keys.num[m]+1);
				break;
			}
			break;
		case 5: //Mouse
			SetEditText(GetDlgItem(hW, l), "Mouse");
			break;
		default: //None
			SetEditText(GetDlgItem(hW, l), "None");
			break;
		}
	}
}

BOOL CALLBACK ConfigureDlgProc(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam){
	HWND text;
	TCITEM tabs;
	unsigned char str[256];
	int i, j, m, key;
	int padn=0;
	char keyName[21];
	int pcsize=sizeof(PadConf);
	switch(uMsg) {
		case WM_INITDIALOG:
			LoadConfig();
			if(!padInit)PADinit(0);
            CheckDlgButton(hW, IDC_LOG, Logging);
			CheckDlgButton(hW, IDC_CURSOR, AlwaysSC);
			CheckDlgButton(hW, IDC_CRSCUR, CrossCur);
			ComboBox_AddString(GetDlgItem(hW, IDC_AXISSENSE), "High");
			ComboBox_AddString(GetDlgItem(hW, IDC_AXISSENSE), "Medium");
			ComboBox_AddString(GetDlgItem(hW, IDC_AXISSENSE), "Low");
			ComboBox_SetCurSel(GetDlgItem(hW, IDC_AXISSENSE), (axisSense/500)-1);
			//Set tabs text
			tabs.mask=TCIF_TEXT;
			tabs.pszText="First pad";
			TabCtrl_InsertItem(GetDlgItem(hW, IDC_TABC), 0, &tabs);
			tabs.pszText="Second pad";
			TabCtrl_InsertItem(GetDlgItem(hW, IDC_TABC), 1, &tabs);
			//Set variables
			padn=TabCtrl_GetCurSel(GetDlgItem(hW, IDC_TABC));
			CheckDlgButton(hW, IDC_ENABLED, Pad[padn][1].enabled);
			//Set buttons
			FillGUI(hW, padn);
			return TRUE;
		case WM_TIMER:
			padn=TabCtrl_GetCurSel(GetDlgItem(hW, IDC_TABC));
			if(disabled){
				memset(str, 0, 256);
				GetKeyboardState(str);
				for (key=0; key<=256; key++)
				{
					if(str[key]&0x80)break;
				}
				if(key==255)key=256;
                if (key<256 && key!=1){
					int i;
					KillTimer(hW, 0x80);
					for(i=IDC_X; i<=IDC_AS; i++)
					{
						if(i==disabled)
						{
							if(i<=IDC_DOWN){
								text=GetDlgItem(hW, i+20);
								m=i-1076;
							}else if(i>=IDC_SELECT && i<=IDC_RDOWN){
								text=GetDlgItem(hW, i+21);
								m=i-1076;
							}else if(i>=IDC_LUP && i<=IDC_LDOWN){
								text=GetDlgItem(hW, i+4);
								m=i-1105;
							}else if(i==IDC_AS){
								text=GetDlgItem(hW, i+1);
								m=24;
							}	
							if(key==27/*Escape*/||key==8/*Backspace*/)
							{
								if(key==8)
								{
									SetEditText(text, "None");
									Pad[padn][1].keys.type[m]=BT_NONE;
									Pad[padn][1].keys.num[m]=0;
									Pad[padn][1].keys.index[m]=0;
									Pad[padn][1].keys.dir[m]=0;
								}
							}else if(key==2 && disabled>=IDC_RUP && disabled<=IDC_RDOWN || key==2 && disabled>=IDC_LUP && disabled<=IDC_LDOWN)
							{
								SetEditText(text, "Mouse");
								Pad[padn][1].keys.type[m]=BT_MOUSE;
								Pad[padn][1].keys.num[m]=0;
								Pad[padn][1].keys.index[m]=0;
								Pad[padn][1].keys.dir[m]=0;
							}else if(key>=3 && (key<0x70 || key>0x7b)) //F1 to F12 are hotkeys.
							{
								if(key>=0x30 && key<=0x39 || key>=0x25 && key<=0x28 || key>=0x21 && key<=0x24 || key>=0x29 && key<=0x2f)
								{
									GetKeyNameText(MapVirtualKey(key, 0)<<16|1<<24, keyName, sizeof(keyName));
								}else{
									GetKeyNameText(MapVirtualKey(key, 0)<<16, keyName, sizeof(keyName));
								}
								SetEditText(text, "%s", keyName);
								Pad[padn][1].keys.type[m]=BT_KEY;
								Pad[padn][1].keys.num[m]=key;
								Pad[padn][1].keys.index[m]=0;
								Pad[padn][1].keys.dir[m]=0;
							}else{
								Beep(1000, 100);
								Beep(500, 500);
							}
							EnableWindow(GetDlgItem(hW, disabled), TRUE);
							disabled=0;
							return TRUE;
						}
					}
					return TRUE;
				}
				//Joystick support.
				SDL_JoystickUpdate();
				if(disabled<=IDC_DOWN){
					text=GetDlgItem(hW, disabled+20);
					m=disabled-1076;
				}else if(disabled>=IDC_SELECT && disabled<=IDC_RDOWN){
					text=GetDlgItem(hW, disabled+21);
					m=disabled-1076;
				}else if(disabled>=IDC_LUP && disabled<=IDC_LDOWN){
					text=GetDlgItem(hW, disabled+4);
					m=disabled-1105;
				}else if(disabled==IDC_AS){
					text=GetDlgItem(hW, disabled+1);
					m=24;
				}
				for(i=1; i<=SDL_NumJoysticks(); i++)
				{
					//Buttons. The button indice starts at 0.
					for(j=1; j<=SDL_JoystickNumButtons(joy[i-1][4]); j++)
					{
						if(SDL_JoystickGetButton(joy[i-1][4], j-1)!=0)
						{
							SetEditText(text, "Joy%i_Button%i", i, j);
							Pad[padn][1].keys.type[m]=BT_JOYBTN;
							Pad[padn][1].keys.num[m]=j-1;
							Pad[padn][1].keys.index[m]=i-1;
							Pad[padn][1].keys.dir[m]=0;
							EnableWindow(GetDlgItem(hW, disabled), TRUE);
							KillTimer(hW, 0x80);
							disabled=0;
							return TRUE;
						}
					}
					//Axes. The axis indice starts at 0. The even axes (0, 2, ...) are horizontal and the odd axes (1, 3, ...) are vertical.
					//Axis control #0 :
					//
					//         -32768
					//         ^..........Axis #1 (Y)
					//-32768   |   32767
					//     <---+--->......Axis #0 (X)
					//         |
					//         v
					//         32767
					//
					for(j=1; j<=SDL_JoystickNumAxes(joy[i-1][4]); j++)
					{
						if(SDL_JoystickGetAxis(joy[i-1][4], j-1)>=axisSense || SDL_JoystickGetAxis(joy[i-1][4], j-1)<=-axisSense)
						{
								if(SDL_JoystickGetAxis(joy[i-1][4], j-1)>=axisSense){
									SetEditText(text, "Joy%i_Axis%i_Max", i, j);
									Pad[padn][1].keys.dir[m]=2;
								}else if(SDL_JoystickGetAxis(joy[i-1][4], j-1)<=-axisSense){
									SetEditText(text, "Joy%i_Axis%i_Min", i, j);
									Pad[padn][1].keys.dir[m]=1;
								}
							Pad[padn][1].keys.type[m]=BT_JOYAXIS;
							Pad[padn][1].keys.num[m]=j-1;
							Pad[padn][1].keys.index[m]=i-1;
							EnableWindow(GetDlgItem(hW, disabled), TRUE);
							KillTimer(hW, 0x80);
							disabled=0;
							return TRUE;
						}
					}
					//POV hats. The hat indice starts at 0. Diagonal suport implemented since version 1.3.0.
					for(j=1; j<=SDL_JoystickNumHats(joy[i-1][4]); j++)
					{
						if(SDL_JoystickGetHat(joy[i-1][4], j-1)!=0)
						{
							Pad[padn][1].keys.dir[m]=SDL_JoystickGetHat(joy[i-1][4], j-1);
								switch(SDL_JoystickGetHat(joy[i-1][4], j-1))
								{
								case 1: //Up
									SetEditText(text, "Joy%i_Hat%i_Up", i, j);
									break;
								case 2: //Right
									SetEditText(text, "Joy%i_Hat%i_Right", i, j);
									break;
								case 3: //Up-Right
									SetEditText(text, "Joy%i_Hat%i_UpRight", i, j);
									break;
								case 4: //Down 
									SetEditText(text, "Joy%i_Hat%i_Down", i, j);
									break;
								case 6: //Down-Right
									SetEditText(text, "Joy%i_Hat%i_DownRight", i, j);
									break;
								case 8: //Left
									SetEditText(text, "Joy%i_Hat%i_Left", i, j);
									break;
								case 9: //Up-Left
									SetEditText(text, "Joy%i_Hat%i_UpLeft", i, j);
									break;
								case 12: //Down-Left
									SetEditText(text, "Joy%i_Hat%i_DownLeft", i, j);
									break;
								}
								Pad[padn][1].keys.type[m]=BT_JOYPOV;
								Pad[padn][1].keys.num[m]=j-1;
								Pad[padn][1].keys.index[m]=i-1;
							EnableWindow(GetDlgItem(hW, disabled), TRUE);
							KillTimer(hW, 0x80);
							disabled=0;
							return TRUE;
						}
					}
				}
			}
			return TRUE;
		case WM_COMMAND:
			switch(LOWORD(wParam)){
				case IDCANCEL:
					KillTimer(hW, 0x80);
					EndDialog(hW, TRUE);
					return TRUE;
				case IDOK:
					KillTimer(hW, 0x80);
					Logging=IsDlgButtonChecked(hW, IDC_LOG);
					AlwaysSC=IsDlgButtonChecked(hW, IDC_CURSOR);
					CrossCur=IsDlgButtonChecked(hW, IDC_CRSCUR);
					axisSense=(ComboBox_GetCurSel(GetDlgItem(hW, IDC_AXISSENSE))+1)*500;
					SaveConfig();
					EndDialog(hW, FALSE);
					return TRUE;
				case IDC_ENABLED:
					Pad[TabCtrl_GetCurSel(GetDlgItem(hW, IDC_TABC))][1].enabled=IsDlgButtonChecked(hW, IDC_ENABLED);
					break;
				case IDC_AS:
					if(disabled)EnableWindow(GetDlgItem(hW, disabled), TRUE);
					disabled=IDC_AS;
					EnableWindow(GetDlgItem(hW, disabled), FALSE);
					SetTimer(hW, 0x80, 250, NULL);
					break;
				default:
					for(i=IDC_X; i<=IDC_LDOWN; i++)
					{
						if(LOWORD(wParam)==i)
						{
						    if(LOWORD(wParam)<=IDC_RDOWN || LOWORD(wParam)>=IDC_LUP && LOWORD(wParam)<=IDC_LDOWN)
							{
								if(disabled)EnableWindow(GetDlgItem(hW, disabled), TRUE);
								disabled=i;
								EnableWindow(GetDlgItem(hW, disabled), FALSE);
								SetTimer(hW, 0x80, 250, NULL);
								return TRUE;
							}
						}
					}
			}
		case WM_NOTIFY:
			switch(wParam){
				case IDC_TABC:
					padn=TabCtrl_GetCurSel(GetDlgItem(hW, IDC_TABC));
					CheckDlgButton(hW, IDC_ENABLED, Pad[padn][1].enabled);
					FillGUI(hW, padn);
					return TRUE;
			}
	}
	return FALSE;
}

BOOL CALLBACK SdlDlgProc(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam){
	switch(uMsg) {
		case WM_INITDIALOG:
			SetEditText(GetDlgItem(hW, IDC_VERSION), "Version %i.%i.%i", SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
			return TRUE;
		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDOK:
					EndDialog(hW, FALSE);
					return TRUE;
				case IDCANCEL:
					EndDialog(hW, TRUE);
					return TRUE;
			}
	}
	return FALSE;
}

BOOL CALLBACK AboutDlgProc(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam){
	switch(uMsg) {
		case WM_INITDIALOG:
			return TRUE;
		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDOK:
					EndDialog(hW, FALSE);
					return TRUE;
				case IDCANCEL:
					EndDialog(hW, TRUE);
					return TRUE;
				case IDC_SDL:
					DialogBox(hInst,
						MAKEINTRESOURCE(IDD_DIALOG3),
						GetActiveWindow(),  
						(DLGPROC)SdlDlgProc);
			}
	}
	return FALSE;
}

u8 StartPoll(int pad){
	LOG("PADstartPoll for pad %i\n", pad);
	uPad=pad-1;
	Byte=0;
	return 0xff;
}

s32 Open(void *pDsp){
	if(padopen==1)return 0;
	LoadConfig();
	GShwnd=(HWND)*(long*)pDsp;
	if(!IsWindow(GShwnd)){
		SysMessage("Serious error : \nFailed to get handle to GS window.\nInput detection depends on it !\nError : %i", GetLastError());
		LOG("Error %i while getting handle to GS window.", GetLastError());
		return -1;
	}
	GSwndProc=SubclassWindow(GShwnd, PadWndProc);
	LOG("Open\n");
	timer=0;
	padopen=1;
	return 0;
}

void Close(){
	LOG("Close\n");
	SubclassWindow(GShwnd, GSwndProc);
	padopen=0;
}

void ShutDown(){
	int i;
	LOG("Shutdown\n");
    if(padLog!=NULL){
        fclose(padLog);
        padLog=NULL;
    }
	//Close pads
	for (i=1; i<=SDL_NumJoysticks(); i++)
	{
		if(i<=5)SDL_JoystickClose(joy[i-1][4]);
	}
	//Close SDL
	SDL_Quit();
}

u8 Poll(u8 value){
	int pcsize=sizeof(PadConf);
	if(!Pad[uPad][1].enabled)PadID[uPad]=0x01;
	if(!Byte)
	{
	LOG("PADpoll : command 0x%x for pad %i\n", value, uPad+1);
	Byte++;
	Command=value;
	switch(value) {
		case 0x40: //Set Vref param
			Length=8;
			Buffer=Cmd40[uPad];
			return 0xf3;
		case 0x41: //Query button mask
			Length=8;
			Buffer=Cmd41[uPad];
			Buffer[2]=ButtonMask[uPad][0];
			Buffer[3]=ButtonMask[uPad][1];
			Buffer[4]=ButtonMask[uPad][2];
			Buffer[5]=ButtonMask[uPad][3];
			return 0xf3;
		case 0x42: //Read buttons status from the pad.
			if(!PadMode[uPad]){
				Length=4;
			}else{
				if(DualShock2)Length=20;
				else Length=8;
			}
			Cmd42[uPad][2]=ButtonStat[uPad]>>8;
			Cmd42[uPad][3]=ButtonStat[uPad]&0xff;
			Cmd42[uPad][4]=rX[uPad];
			Cmd42[uPad][5]=rY[uPad];
			Cmd42[uPad][6]=lX[uPad];
			Cmd42[uPad][7]=lY[uPad];
			//Pressure sensitive buttons
			//If an axis has been bound to one of these buttons, the pressure will be the value of the axis,
			//else the pressure will be 255 (max).
				switch(Cmd42[uPad][2]>>4)
				{
				case 0xd: //Right
					Cmd42[uPad][8]=pressure[uPad];
					break;
				case 0x7: //Left
					Cmd42[uPad][9]=pressure[uPad];
					break;
				case 0xe: //Up
					Cmd42[uPad][10]=pressure[uPad];
					break;
				case 0xb: //Down
					Cmd42[uPad][11]=pressure[uPad];
					break;
				default: //None pressed
					Cmd42[uPad][8]=0;
					Cmd42[uPad][9]=0;
					Cmd42[uPad][10]=0;
					Cmd42[uPad][11]=0;
					break;
				}
				switch(Cmd42[uPad][3])
				{
				case 0xef: //Triangle
					Cmd42[uPad][12]=pressure[uPad];
					break;
				case 0xdf: //Circle
					Cmd42[uPad][13]=pressure[uPad];
					break;
				case 0xbf: //X
					Cmd42[uPad][14]=pressure[uPad];
					break;
				case 0x7f: //Square
					Cmd42[uPad][15]=pressure[uPad];
					break;
				case 0xfb: //L1
					Cmd42[uPad][16]=pressure[uPad];
					break;
				case 0xf7: //R1
					Cmd42[uPad][17]=pressure[uPad];
					break;
				case 0xfe: //L2
					Cmd42[uPad][18]=pressure[uPad];
					break;
				case 0xfd: //R2
					Cmd42[uPad][19]=pressure[uPad];
					break;
				default: //None pressed
					Cmd42[uPad][12]=0;
					Cmd42[uPad][13]=0;
					Cmd42[uPad][14]=0;
					Cmd42[uPad][15]=0;
					Cmd42[uPad][16]=0;
					Cmd42[uPad][17]=0;
					Cmd42[uPad][18]=0;
					Cmd42[uPad][19]=0;
					break;
				}
			Buffer=Cmd42[uPad];
			return PadID[uPad];
		case 0x43: //Enter/exit config mode
			Length=8;
			Buffer=Cmd43[uPad];
			if (ConfMode[uPad]){return 0xf3;}
			else{return PadID[uPad];}
		case 0x44: //Set main mode
			Length=8;
			Buffer=Cmd44[uPad];
			return 0xf3;
		case 0x45: //Query model
			Length=8;
			Buffer=Cmd45[uPad];
			Buffer[4]=PadMode[uPad];
			return 0xf3;
		case 0x46: //Query act
			Length=8;
			Buffer=Cmd46[uPad];
			return 0xf3;
		case 0x47: //Query comb
			Length=8;
			Buffer=Cmd47[uPad];
			return 0xf3;
		case 0x4c: //Query mode
			Length=8;
			Buffer=Cmd4C[uPad];
			return 0xf3;
		case 0x4d: //Set act align (vibration enable)
			Length=8;
			Buffer=Cmd4D[uPad];
			return 0xf3;
		case 0x4f: //Set button mask
			Length=8;
			DualShock2=1;
			PADsetMode(uPad, 1);
			Buffer=Cmd4F[uPad];
			return 0xf3;
	}
	}
	switch(Command) {
		case 0x43: //Config
			if(Byte==2){
				ConfMode[uPad]=value;
				switch(value){
				case 0: //Exit config mode
					Buffer[2]=0;
					Buffer[3]=0;
					break;
				case 1: //Enter config mode
					Buffer[2]=0xff;
					Buffer[3]=0xff;
					break;
				}
			}
		case 0x44: //Set main mode
			//Set mode
			if(Byte==2){
				if(!Locked[uPad])PADsetMode(uPad, value);
			}
			//Lock
			if(Byte==3){
				if(!Locked[uPad])Locked[uPad]=value;
			}
			break;
		case 0x46: //Query act (vibration related) (SDL does not support vibration yet)
			if(Byte==2){
				switch(value){
				case 0: //Dualshock small motor (100 mA)
					Buffer[5] = 0x02; //Subfunction (1 : lo, 2 : hi)
					Buffer[6] = 0x00; //Length (0 : on-off, 1 or more : number of bytes)
					Buffer[7] = 0x0A; //Curr (10 mA units)
					break;
				case 1: //Dualshock big motor (200 mA)
					Buffer[5] = 0x01; //Subfunction (1 : lo, 2 : hi)
					Buffer[6] = 0x01; //Length (0 : on-off, 1 or more : number of bytes)
					Buffer[7] = 0x14; //Curr (10 mA units)
					break;
				}
			}
			break;
		case 0x4c: //Query mode (vibration enable)
			if(Byte==2){
				switch (value){
					case 0: //Digital
						Buffer[5] = 0x04;
						break;
					case 1: //Analog
						Buffer[5] = 0x07;
						break;
				}
			}
			break;
		case 0x4f: //Set button mask
			if(Byte>=2 && Byte<=5){
				ButtonMask[uPad][Byte-2]=value;
			}
			break;
	}
	if(Byte>=Length)return 0;
	return Buffer[Byte++];
}

double divX=0, divY=0;
int xPos=0, yPos=0;
int axisOn[8];

//PadWndProc - Does a great party of the work by detecting the inputs.

LRESULT WINAPI PadWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	int axisValue=0;
	int k;
	int key;
	unsigned char str[256];
	int keyState[256];
	switch(msg){
		case WM_TIMER:
				memset(str, 0, 256);
				GetKeyboardState(str);
					for(key=0; key<256; key++)
					{
						if(str[key]&0x80 && (key<0x70 || key>0x7b))
						{
							keyState[key]=1;
							KeyEvent.event=KEYPRESS;
							KeyEvent.key=key;
						}else if(str[key]&0x80 && key>=0x70 && key<=0x7b){
							KeyEvent.event=KEYPRESS;
							KeyEvent.key=key;
							return TRUE;
						}else{
							keyState[key]=0;
							KeyEvent.event=KEYRELEASE;
							KeyEvent.key=0;
						}
					}
					SDL_JoystickUpdate();
					for(k=0; k<24; k++)
					{
						if(Pad[0][1].enabled==1 && (keyState[Pad[0][1].keys.num[k]]==1 && Pad[0][1].keys.type[k]==BT_KEY || 
							SDL_JoystickGetButton(joy[Pad[0][1].keys.index[k]][4], Pad[0][1].keys.num[k]) && Pad[0][1].keys.type[k]==BT_JOYBTN ||
							(SDL_JoystickGetHat(joy[Pad[0][1].keys.index[k]][4], Pad[0][1].keys.num[k])==Pad[0][1].keys.dir[k] ||
							SDL_JoystickGetHat(joy[Pad[0][1].keys.index[k]][4], Pad[0][1].keys.num[k])==(Pad[0][1].keys.dir[k]|1) ||
							SDL_JoystickGetHat(joy[Pad[0][1].keys.index[k]][4], Pad[0][1].keys.num[k])==(Pad[0][1].keys.dir[k]|2) ||
							SDL_JoystickGetHat(joy[Pad[0][1].keys.index[k]][4], Pad[0][1].keys.num[k])==(Pad[0][1].keys.dir[k]|4) ||
							SDL_JoystickGetHat(joy[Pad[0][1].keys.index[k]][4], Pad[0][1].keys.num[k])==(Pad[0][1].keys.dir[k]|8))&& Pad[0][1].keys.type[k]==BT_JOYPOV))
						{
							SetButtonState(0, k, 1, 255);
						}else if(Pad[0][1].enabled==1 && (SDL_JoystickGetAxis(joy[Pad[0][1].keys.index[k]][4], Pad[0][1].keys.num[k])<=-axisSense && Pad[0][1].keys.dir[k]==1 ||
							SDL_JoystickGetAxis(joy[Pad[0][1].keys.index[k]][4], Pad[0][1].keys.num[k])>=axisSense && Pad[0][1].keys.dir[k]==2) && Pad[0][1].keys.type[k]==BT_JOYAXIS){
							axisValue=SDL_JoystickGetAxis(joy[Pad[0][1].keys.index[k]][4], Pad[0][1].keys.num[k]);
							SetButtonStateJA(0, k, axisValue, Pad[0][1].keys.dir[k]);
						}else{
							SetButtonState(0, k, 0, 0);
						}
						//----------------------
						if(Pad[1][1].enabled==1 && (keyState[Pad[1][1].keys.num[k]]==1 && Pad[1][1].keys.type[k]==BT_KEY || 
							SDL_JoystickGetButton(joy[Pad[1][1].keys.index[k]][4], Pad[1][1].keys.num[k]) && Pad[1][1].keys.type[k]==BT_JOYBTN ||
							(SDL_JoystickGetHat(joy[Pad[1][1].keys.index[k]][4], Pad[1][1].keys.num[k])==Pad[1][1].keys.dir[k] ||
							SDL_JoystickGetHat(joy[Pad[1][1].keys.index[k]][4], Pad[1][1].keys.num[k])==(Pad[1][1].keys.dir[k]|1) ||
							SDL_JoystickGetHat(joy[Pad[1][1].keys.index[k]][4], Pad[1][1].keys.num[k])==(Pad[1][1].keys.dir[k]|2) ||
							SDL_JoystickGetHat(joy[Pad[1][1].keys.index[k]][4], Pad[1][1].keys.num[k])==(Pad[1][1].keys.dir[k]|4) ||
							SDL_JoystickGetHat(joy[Pad[1][1].keys.index[k]][4], Pad[1][1].keys.num[k])==(Pad[1][1].keys.dir[k]|8))&& Pad[1][1].keys.type[k]==BT_JOYPOV))
						{
							SetButtonState(1, k, 1, 255);
						}else if(Pad[1][1].enabled==1 && (SDL_JoystickGetAxis(joy[Pad[1][1].keys.index[k]][4], Pad[1][1].keys.num[k])<=-axisSense && Pad[1][1].keys.dir[k]==1 ||
							SDL_JoystickGetAxis(joy[Pad[1][1].keys.index[k]][4], Pad[1][1].keys.num[k])>=axisSense && Pad[1][1].keys.dir[k]==2) && Pad[1][1].keys.type[k]==BT_JOYAXIS){
							axisValue=SDL_JoystickGetAxis(joy[Pad[1][1].keys.index[k]][4], Pad[1][1].keys.num[k]);
							SetButtonStateJA(0, k, axisValue, Pad[1][1].keys.dir[k]);
						}else{
							SetButtonState(1, k, 0, 0);
						}
					}
			return TRUE;
		case WM_LBUTTONDOWN:
			lbutton=1;
			SetCursorPos(WinCenterOnScr.x, WinCenterOnScr.y);
			ClipCursor(&WinClipSize);
			return TRUE;
		case WM_LBUTTONUP:
			lX[0]=128;
			lY[0]=128;
			lbutton=0;
			ClipCursor(NULL);
			return TRUE;
		case WM_RBUTTONDOWN:
			rbutton=1;
			SetCursorPos(WinCenterOnScr.x, WinCenterOnScr.y);
			ClipCursor(&WinClipSize);
			return TRUE;
		case WM_RBUTTONUP:
			rX[0]=128;
			rY[0]=128;
			rbutton=0;
			ClipCursor(NULL);
			return TRUE;
		case WM_MOUSEMOVE:
			if(AlwaysSC){ShowCursor(TRUE);if(!CrossCur)SetCursor(LoadCursor(NULL, IDC_ARROW));}
			if(CrossCur)SetCursor(LoadCursor(NULL, IDC_CROSS));
			if(rbutton||lbutton)
			{
				divX=WinSize.right/255;
				divY=WinSize.bottom/255;
				xPos=(int)ceil(LOWORD(lParam)/divX)+2;
				yPos=(int)ceil(HIWORD(lParam)/divY)-22;
				if(xPos<0)xPos=0; if(xPos>255)xPos=255;
				if(yPos<0)yPos=0; if(yPos>255)yPos=255;
				}
			if(rbutton) //Right axis
			{
				if(Pad[0][1].keys.type[17]==5 || Pad[0][1].keys.type[18]==5)rX[0]=xPos;
				if(Pad[1][1].keys.type[17]==5 || Pad[1][1].keys.type[18]==5)rX[1]=xPos;
				if(Pad[0][1].keys.type[16]==5 || Pad[0][1].keys.type[19]==5)rY[0]=yPos;
				if(Pad[1][1].keys.type[16]==5 || Pad[1][1].keys.type[19]==5)rY[1]=yPos;
			}
			if(lbutton) //Left axis
			{
				if(Pad[0][1].keys.type[21]==5 || Pad[0][1].keys.type[22]==5)lX[0]=xPos;
				if(Pad[1][1].keys.type[21]==5 || Pad[1][1].keys.type[22]==5)lX[1]=xPos;
				if(Pad[0][1].keys.type[20]==5 || Pad[0][1].keys.type[23]==5)lY[0]=yPos;
				if(Pad[1][1].keys.type[20]==5 || Pad[1][1].keys.type[23]==5)lY[1]=yPos;
			}
			return TRUE;
		case WM_DESTROY:
		case WM_QUIT:
			//Properly close the emu by simulating an escape.
			//When you close the emu by the X button on the GS window,
			//the emu isn't properly closed, and then the plugin cannot 
			//close the SDL properly...
			KillTimer(hWnd, 0x80);
			KeyEvent.event=KEYPRESS;
			KeyEvent.key=27;
		    return TRUE;
		case WM_SIZE:
			GetWindowRect(hWnd, &WinSize); 
			//Readjust the size of the GS window
			WinCenterOnScr.x=WinSize.left+((WinSize.right-WinSize.left)/2);
			WinCenterOnScr.y=WinSize.top+((WinSize.bottom-WinSize.top)/2);
			//Fill another RECT structure for proper cursor clipping.
			WinClipSize.top=WinSize.top+30;
			WinClipSize.left=WinSize.left+10;
			WinClipSize.bottom=WinSize.bottom-10;
			WinClipSize.right=WinSize.right-10;
			return TRUE;
	    default:
			if(!timer){SetTimer(hWnd, 0x80, 50, NULL);timer=1;}
			//Retrieve the size of the GS window
			GetWindowRect(hWnd, &WinSize);
			WinCenterOnScr.x=WinSize.left+((WinSize.right-WinSize.left)/2);
			WinCenterOnScr.y=WinSize.top+((WinSize.bottom-WinSize.top)/2);
			//Fill another RECT structure for proper cursor clipping.
			WinClipSize.top=WinSize.top+30;
			WinClipSize.left=WinSize.left+10;
			WinClipSize.bottom=WinSize.bottom-10;
			WinClipSize.right=WinSize.right-10;
			//Misc
			if(AlwaysSC){ShowCursor(TRUE);if(!CrossCur)SetCursor(LoadCursor(NULL, IDC_ARROW));}
			if(CrossCur)SetCursor(LoadCursor(NULL, IDC_CROSS));
			//Return
			return GSwndProc(hWnd, msg, wParam, lParam);
	}

	return FALSE;
}

void Configure(){
	DialogBox(hInst,
              MAKEINTRESOURCE(IDD_DIALOG1),
              GetActiveWindow(),  
              (DLGPROC)ConfigureDlgProc);
}

void About(){
	DialogBox(hInst,
              MAKEINTRESOURCE(IDD_DIALOG2),
              GetActiveWindow(),  
              (DLGPROC)AboutDlgProc);
}

s32 Test(){
	if(sdlResult==0){
		SysMessage("SDL version %i.%i.%i", SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
		return 0;
	}else{
		SysMessage("Error %i while loading SDL", SDL_GetError());
		return 1;
	}
}

u32 CALLBACK PS2EgetLibType(){
	return PS2E_LT_PAD;
}

char* CALLBACK PS2EgetLibName(){
	return libraryName;
}

u32 CALLBACK PS2EgetLibVersion2(u32 type){
	return(version<<16)|(revision<<8)|major|(minor<<24);
	
}

BOOL APIENTRY DllMain(HANDLE hModule,                  // DLL INIT
                      DWORD  dwReason, 
                      LPVOID lpReserved){
	if(dwReason==DLL_PROCESS_ATTACH){	
		hInst=(HINSTANCE)hModule;
	}
	return TRUE;
}

